Initial commit
[clearscm.git] / CCDB / etc / ccdbservice
1 #!/bin/sh
2 ### BEGIN INIT INFO
3 # Provides:          ccdbservice
4 # Required-Start:    $network
5 # Required-Stop:     none
6 # Default-Start:     2 3 4 5
7 # Default-Stop:      0 1 6
8 # Short-Description: Starts the ccdbservice daemon
9 # Description:       CCDBService is part of the CCDB package. It is a daemon
10 #                    that runs in the background and responds to triggers which
11 #                    indicate updates to Clearcase UCM data. Such data is stored
12 #                    in CCDB in order to provide quicker access to UCM metadata.
13 ### END INIT INFO
14
15 # Author: Andrew DeFaria <Andrew@ClearSCM.com>
16 #
17 # Do NOT "set -e"
18
19 # PATH should only include /usr/* if it runs after the mountnfs.sh script
20 PATH=/sbin:/usr/sbin:/bin:/usr/bin
21 DESC="CCDB Service"
22 NAME=ccdbservice.pl
23
24 # Need to determine where this gets place. For now this is the path into my
25 # development view
26 CCDBBASE=/view/adefaria_tools/vob/adpscmtools/CCDB
27 DAEMON=$CCDBBASE/$NAME
28 PIDFILE=$CCDBBASE/$NAME.pid
29 DAEMON_ARGS=""
30 SCRIPTNAME=/etc/init.d/$NAME
31 RUNASUSER="ccdb"
32
33 # Exit if the package is not installed
34 [ -x "$DAEMON" ] || exit 0
35
36 # Read configuration variable file if it is present
37 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
38
39 # Load the VERBOSE setting and other rcs variables
40 . /lib/init/vars.sh
41
42 # Define LSB log_* functions.
43 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
44 . /lib/lsb/init-functions
45
46 #
47 # Function that starts the daemon/service
48 #
49 do_start()
50 {
51         # Return
52         #   0 if daemon has been started
53         #   1 if daemon was already running
54         #   2 if daemon could not be started
55         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
56                 || return 1
57         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON \
58                 --chuid $RUNASUSER \
59                 -- $DAEMON_ARGS \
60                 || return 2
61 }
62
63 #
64 # Function that stops the daemon/service
65 #
66 do_stop()
67 {
68         # Return
69         #   0 if daemon has been stopped
70         #   1 if daemon was already stopped
71         #   2 if daemon could not be stopped
72         #   other if a failure occurred
73         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
74         RETVAL="$?"
75         [ "$RETVAL" = 2 ] && return 2
76         # Wait for children to finish too if this is a daemon that forks
77         # and if the daemon is only ever run from this initscript.
78         # If the above conditions are not satisfied then add some other code
79         # that waits for the process to drop all resources that could be
80         # needed by services started subsequently.  A last resort is to
81         # sleep for some time.
82         start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
83         [ "$?" = 2 ] && return 2
84         # Many daemons don't delete their pidfiles when they exit.
85         rm -f $PIDFILE
86         return "$RETVAL"
87 }
88
89 #
90 # Function that sends a SIGHUP to the daemon/service
91 #
92 do_reload() {
93         #
94         # If the daemon can reload its configuration without
95         # restarting (for example, when it is sent a SIGHUP),
96         # then implement that here.
97         #
98         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
99         return 0
100 }
101
102 case "$1" in
103   start)
104         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
105         do_start
106         case "$?" in
107                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
108                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
109         esac
110         ;;
111   stop)
112         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
113         do_stop
114         case "$?" in
115                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
116                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
117         esac
118         ;;
119   status)
120        status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
121        ;;
122   #reload|force-reload)
123         #
124         # If do_reload() is not implemented then leave this commented out
125         # and leave 'force-reload' as an alias for 'restart'.
126         #
127         #log_daemon_msg "Reloading $DESC" "$NAME"
128         #do_reload
129         #log_end_msg $?
130         #;;
131   restart|force-reload)
132         #
133         # If the "reload" option is implemented then remove the
134         # 'force-reload' alias
135         #
136         log_daemon_msg "Restarting $DESC" "$NAME"
137         do_stop
138         case "$?" in
139           0|1)
140                 do_start
141                 case "$?" in
142                         0) log_end_msg 0 ;;
143                         1) log_end_msg 1 ;; # Old process is still running
144                         *) log_end_msg 1 ;; # Failed to start
145                 esac
146                 ;;
147           *)
148                 # Failed to stop
149                 log_end_msg 1
150                 ;;
151         esac
152         ;;
153   *)
154         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
155         echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
156         exit 3
157         ;;
158 esac
159
160 :